<?php
use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \frontend\models\SignupForm */

$this->title = 'Inscription';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-signup">
    <h1 class="title-systeme-commande"><span class="glyphicon glyphicon-user"></span>&nbsp;&nbsp;<?= Html::encode($this->title) ?></h1>
    
    <div class="row">
        <div class="col-lg-5">
            <?php $form = ActiveForm::begin(['id' => 'form-signup','enableClientValidation'=> false]); ?>
                <?= $form->field($model, 'email') ?>
                <?= $form->field($model, 'password')->passwordInput() ?>
                <?= $form->field($model, 'nom') ?>
                <?= $form->field($model, 'prenom') ?>
                <?= $form->field($model, 'telephone') ?>
                <?php //$form->field($model, 'is_boulanger')->checkbox() ?>
            
                <div id="client-boulanger" class="btn-group" data-toggle="buttons">
                    <label class="btn btn-default <?php if($model->option_client_boulanger == 'client' || !$model->option_client_boulanger): ?>active<?php endif; ?>">
                      <input type="radio" name="SignupForm[option_client_boulanger]" value="client" id="option-client" autocomplete="off" <?php if($model->option_client_boulanger == 'client' || !$model->option_client_boulanger): ?>checked<?php endif; ?>> Je suis client
                    </label>
                    <label class="btn btn-default <?php if($model->option_client_boulanger == 'boulanger'): ?>active<?php endif; ?>">
                      <input type="radio" name="SignupForm[option_client_boulanger]" value="boulanger" id="option-boulanger" autocomplete="off" <?php if($model->option_client_boulanger == 'boulanger'): ?>checked<?php endif; ?>> Je suis boulanger
                    </label>
                </div>
            
                <div id="champs-boulanger">
                    <?= $form->field($model, 'nom_magasin') ?>
                    <?= $form->field($model, 'siret') ?>
                    <?= $form->field($model, 'code_postal') ?>
                    <?= $form->field($model, 'ville') ?>
                </div>
                <div id="champs-client">
                    <?= $form->field($model, 'id_etablissement')->dropDownList($data_etablissements_dispos, ['prompt' => '--','encode' => false,'options' => $options_etablissements_dispos]) ?>
                </div>
            
                <div class="form-group" id="boutons-inscrire">
                    <?= Html::submitButton("S'inscrire", ['class' => 'btn btn-primary', 'name' => 'signup-button']) ?>
                </div>
            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>
